
#declare mu = 0.9;
#declare nu = 0.3;

#declare m1 = mu*nu;
#declare m2 = mu*(1-nu);
#declare m3 = 1 - mu;


#default{
 finish{
  ambient 0.3
  diffuse 0.7
 }
}

#declare dist1 = function(x, y, z) {
 sqrt(pow(x + 0.5, 2) + pow(y, 2) + pow(z + 0.5/sqrt(3), 2))
}
#declare dist2 = function(x, y, z) {
 sqrt(pow(x - 0.5, 2) + pow(y, 2) + pow(z + 0.5/sqrt(3), 2))
}
#declare dist3 = function(x, y, z) {
 sqrt(pow(x, 2) + pow(y, 2) + pow(z - 1/sqrt(3), 2))
}

#declare pos1 = <-0.5, 0, -0.5/sqrt(3)>;
#declare pos2 = pos1*<-1, 1, 1>;
#declare pos3 = pos1*<0, 1, -2>;

#declare centerOfMass = m1*pos1 + m2*pos2 + m3*pos3;

#declare potential = function(x, y, z) {
 (pow(x+(m1-m2)/2, 2) + pow(z+(m1+m2-2*m3)/2/sqrt(3), 2))/2 + m1/dist1(x, y, z) + m2/dist2(x, y, z) + m3/dist3(x, y, z)
}

#declare potential_x = function(x, y, z) {
 x+(m1-m2)/2 - m1*(x+0.5)/pow(dist1(x, y, z), 3) - m2*(x-0.5)/pow(dist2(x, y, z), 3) - m3*x/pow(dist3(x, y, z), 3)
}
#declare potential_z = function(x, y, z) {
 z+(m1+m2-2*m3)/2/sqrt(3) - m1*(z + 0.5/sqrt(3))/pow(dist1(x, y, z), 3) - m2*(z + 0.5/sqrt(3))/pow(dist2(x, y, z), 3) - m3*(z - 1/sqrt(3))/pow(dist3(x, y, z), 3)
}
#declare potential_xx = function(x, y, z) {
 1 - m1*(pow(z+0.5/sqrt(3), 2)-2*pow(x+0.5, 2))/pow(dist1(x, y, z), 5) - m2*(pow(z+0.5/sqrt(3), 2)-2*pow(x-0.5, 2))/pow(dist2(x, y, z), 5) - m3*(pow(z-1/sqrt(3), 2)-2*pow(x, 2))/pow(dist3(x, y, z), 5)
}
#declare potential_zz = function(x, y, z) {
 1 - m1*(pow(x+0.5, 2)-2*pow(z+0.5/sqrt(3), 2))/pow(dist1(x, y, z), 5) - m2*(pow(x-0.5, 2)-2*pow(z+0.5/sqrt(3), 2))/pow(dist2(x, y, z), 5) - m3*(pow(x, 2)-2*pow(z-1/sqrt(3), 2))/pow(dist3(x, y, z), 5)
}
#declare potential_xz = function(x, y, z) {
 3*(
  m1*(x+0.5)*(z+0.5/sqrt(3))/pow(dist1(x, y, z), 5) + m2*(x-0.5)*(z+0.5/sqrt(3))/pow(dist2(x, y, z), 5) + m3*x*(z-1/sqrt(3))/pow(dist3(x, y, z), 5)
 )
}
#declare potential_nablaQuadrat = function(x, y, z) {
 pow(potential_x(x, y, z), 2) + pow(potential_z(x, y, z), 2)
}
#declare vxSqVyyPlusVySqVxxMal4_xyz = function(x, y, z) {
 (pow(potential_x(x, y, z), 2)*potential_zz(x, y, z) + pow(potential_z(x, y, z), 2)*potential_xx(x, y, z))*4
}
#declare Lambda = function(x, y, z) {
 pow(potential_x(x, y, z), 2)*potential_zz(x, y, z) - 2*potential_x(x, y, z)*potential_z(x, y, z)*potential_xz(x, y, z) + pow(potential_z(x, y, z), 2)*potential_xx(x, y, z)
}
/*
#declare d_num = 0.0001;
#declare potential_xx_num = function(x, y, z) {
 (potential_x(x+d_num/2, y, z) - potential_x(x-d_num/2, y, z))/d_num
}
#declare potential_xz_num = function(x, y, z) {
 (potential_x(x, y, z+d_num/2) - potential_x(x, y, z-d_num/2))/d_num
}
#declare potential_zx_num = function(x, y, z) {
 (potential_z(x+d_num/2, y, z) - potential_z(x-d_num/2, y, z))/d_num
}
#declare potential_zz_num = function(x, y, z) {
 (potential_z(x, y, z+d_num/2) - potential_z(x, y, z-d_num/2))/d_num
}
*/

/*
#declare potential_abc = function(a, b, c) {
 m1*(pow(a, 2)/2 + 1/a) + m2*(pow(b, 2)/2 + 1/b) + m3*(pow(c, 2)/2 + 1/c)
}
#declare potential_nablaQuadrat_abc = function(a, b, c) {
 m1*pow(a, 2) + m2*pow(b, 2) + m3*pow(c, 2)
 +(pow(m1, 2) + pow(m2, 2) + pow(m3, 2) -1)/2
 -(m1/pow(a, 3) + m2/pow(b, 3) + m3/pow(c, 3))*(m1*pow(a, 2) + m2*pow(b, 2) + m3*pow(c, 2)) -(m1/a + m2/b + m3/c)
 +(1-m1)*m1/pow(a, 3) + (1-m2)*m2/pow(b, 3) + (1-m3)*m3/pow(c, 3)
 +(m1/pow(a, 3) + m2/pow(b, 3) + m3/pow(c, 3))*(m1/a + m2/b + m3/c)
 -(m1/pow(a, 3))*(m2/pow(b, 3)) -(m2/pow(b, 3))*(m3/pow(c, 3)) -(m3/pow(c, 3))*(m1/pow(a, 3))
}

#declare potential_xx_abc = function(a, b, c) {
 1 - (
    m1*(-3*pow(pow(a, 2)-pow(b, 2), 2) - 2*pow(a, 2) + 6*pow(b, 2) - 3)/pow(a, 5)
  + m2*(-3*pow(pow(a, 2)-pow(b, 2), 2) + 6*pow(a, 2) - 2*pow(b, 2) - 3)/pow(b, 5)
  + m3*(-3*pow(pow(a, 2)-pow(b, 2), 2) + 4*pow(c, 2))/pow(c, 5)
 )/4
}

#declare potential2 = function(x, y, z) {
 potential_abc(dist1(x, y, z), dist2(x, y, z), dist3(x, y, z))
}
#declare potential_nablaQuadrat2 = function(x, y, z) {
 potential_nablaQuadrat_abc(dist1(x, y, z), dist2(x, y, z), dist3(x, y, z))
}
#declare potential_xx2 = function(x, y, z) {
 potential_xx_abc(dist1(x, y, z), dist2(x, y, z), dist3(x, y, z))
}
*/

/*
#declare centerDist = function(x, y, z) {
 (pow(dist1(x, y, z), 2) + pow(dist2(x, y, z), 2) + pow(dist3(x, y, z), 2) -1)/3
}
#declare centerDistAlt = function(x, y, z) {
 (pow(dist1(x, y, z), 4) + pow(dist2(x, y, z), 4) + pow(dist3(x, y, z), 4)
 -pow(dist2(x, y, z), 2)*pow(dist3(x, y, z), 2) -pow(dist3(x, y, z), 2)*pow(dist1(x, y, z), 2) -pow(dist1(x, y, z), 2)*pow(dist2(x, y, z), 2))/3
}
*/

#declare rBase = 0.07;

#macro planet(pos, mass)
 sphere{ pos, rBase*pow(3*abs(mass), 1/3) pigment{ #if(mass>0) rgb <0.5, 0.5, 0.5> #else rgb <0.7, 0, 0> #end } }
#end

planet(pos1, m1)
planet(pos2, m2)
planet(pos3, m3)


#switch(min(m1, m2, m3))
#case(m1)
 #local maxp = -2*pos1;
 #break
#case(m2)
 #local maxp = -2*pos2;
 #break
#else
 #local maxp = -2*pos3;
#end
#while(potential_nablaQuadrat(maxp.x, maxp.y, maxp.z)!=0)

 #local sdir = <-potential_x(maxp.x, maxp.y, maxp.z)*potential_xx(maxp.x, maxp.y, maxp.z)-potential_z(maxp.x, maxp.y, maxp.z)*potential_xz(maxp.x, maxp.y, maxp.z), 0, -potential_x(maxp.x, maxp.y, maxp.z)*potential_xz(maxp.x, maxp.y, maxp.z)-potential_z(maxp.x, maxp.y, maxp.z)*potential_zz(maxp.x, maxp.y, maxp.z)>;
 #local alph = potential_nablaQuadrat(maxp.x, maxp.y, maxp.z)/vdot(sdir, sdir)/2;

 #local maxp = maxp + alph*sdir;

//#debug concat("  maxp[0] = ", vstr(3, maxp, ", ", 0, 4), "\n")

#end

#local pmax = potential(maxp.x, maxp.y, maxp.z);


#declare sigmoid = function(x) {
 1/(1 + exp(-x))
}

#declare fs = function(x) {
 max(1-exp(-x), 0)
}

plane{ y, 0 hollow no_shadow
 pigment{
  function{
   fs(potential(x, y, z)-pmax)
  }
  color_map{
   [ 0, rgb <1, 1, 1> ]
   [ 1/6, rgb <1, 0, 0> ]
   [ 2/6, rgb <0.95, 0.95, 0> ]
   [ 3/6, rgb <0, 0.97, 0> ]
   [ 4/6, rgb <0, 0.9, 0.9> ]
   [ 5/6, rgb <0, 0, 0.9> ]
   [ 1, rgb <0, 0, 0> ]
  }
 }
 finish{
  ambient 1
  diffuse 0
 }
}
/*
isosurface{
 function{
  2*(y-m1/sqrt(m2*m2+m2*m3+m3*m3) -m2/sqrt(m3*m3+m3*m1+m1*m1) -m3/sqrt(m1*m1+m1*m2+m2*m2))*dist1(x, 0, z)*dist2(x, 0, z)*dist3(x, 0, z)
   + m1*dist2(x, 0, z)*dist3(x, 0, z)*(2+pow(dist1(x, 0, z), 3))
   + m2*dist3(x, 0, z)*dist1(x, 0, z)*(2+pow(dist2(x, 0, z), 3))
   + m3*dist1(x, 0, z)*dist2(x, 0, z)*(2+pow(dist3(x, 0, z), 3))
 }
 max_gradient 277
 accuracy 0.005
 //- 0 = m1 a^3 bc + m2 a b^3 c + m3 ab c^3 + 2 m1 bc + 2 m2 ac + 2 m3 ab - 2V abc
 contained_by{ box{ <-3, -10, -3>, <3, 5, 3> } }
 open
 pigment{
  gradient y
  scale 1/4
  color_map{
   [ 0, rgbt <0, 1, 0, 0.7> ]
   [ 0.45, rgbt <0, 1, 0, 0.7> ]
   [ 0.45, rgbt <1, 1, 1, 0> ]
   [ 0.55, rgbt <1, 1, 1, 0> ]
   [ 0.55, rgbt <0, 1, 0, 0.7> ]
   [ 1, rgbt <0, 1, 0, 0.7> ]
  }
 }
 no_shadow
}
*/

light_source{ <0, 100, 0> color rgb 1 shadowless }

camera{

 orthographic

 right (5*image_width/image_height)*x
 up 5*y
 direction 5*z

 sky centerOfMass

 location <0, 5, 0> + centerOfMass
 look_at centerOfMass
}